/* amiga/amiga.c: Amiga support code

   Copyright (c) 1990-91 Corey Gehman, James E. Wilson

   This software may be copied and distributed for educational, research, and
   not for profit purposes provided that this copyright and statement are
   included in all such copies. */

#include <stdio.h>
#include <intuition/intuition.h>

static int xpos= 0,ypos= 0;
/* static UBYTE savedscreen[640*200>>3]; CBG */
UBYTE *savedscreen=0;

extern struct Window *wd;
extern struct Screen *sc;

char *cleanstr(string)
char *string;
{
   static char newstring[120],ch;
   int i,j;

   j=0;
   for (i=0;i<strlen(string);i++) {
      ch=string[i];
      if (ch=='\t') {
         do {
            newstring[j++]=' ';
         } while (j%8);
      } else if ((ch!=(char)10) && (ch!=(char)13)) {
         newstring[j++]=ch;
      }
   }
   newstring[j]=0;
   return(newstring);
}

move(y,x)
int y,x;
{
   xpos=x;
   ypos=y;
   Move(&(sc->RastPort),xpos<<3,((ypos+1)<<3));
}

sleep(secs)
int secs;
{
   sendtimer(secs*1000000);
   waittimer();
}

getxy(x,y)
int *x,*y;
{
   *x=xpos;
   *y=ypos;
}

mvaddstr(row,col,string)
int row,col;
char *string;
{
   char *newstring;

   newstring=cleanstr(string);
   Move(&(sc->RastPort),col<<3,((row+1)<<3));
   Text(&(sc->RastPort),newstring,strlen(newstring));
   xpos=col+strlen(newstring);
   ypos=row;
}

mvaddch(row,col,ch)
int row,col;
char ch;
{
   char temp[2];
   char *newstring;

   temp[0]=ch;
   temp[1]=0;
   newstring=cleanstr(temp);
   Move(&(sc->RastPort),col<<3,((row+1)<<3));
   Text(&(sc->RastPort),newstring,strlen(newstring));
   xpos=col+strlen(newstring);
   ypos=row;
}

addstr(string)
char *string;
{
   char *newstring;

   newstring=cleanstr(string);
   Text(&(sc->RastPort),newstring,strlen(newstring));
   xpos+=strlen(newstring);
}

addch(ch)
char ch;
{
   char temp[2];
   char *newstring;

   temp[0]=ch;
   temp[1]=0;
   newstring=cleanstr(temp);
   Text(&(sc->RastPort),newstring,strlen(newstring));
   xpos+=strlen(newstring);
}

clear()
{
   Move(&(sc->RastPort),0,0);
   ClearScreen(&(sc->RastPort));
}

clrtoeol()
{
   ClearEOL(&(sc->RastPort));
}

clrtobot()
{
   ClearScreen(&(sc->RastPort));
}

check_input(microsecs)
int microsecs;
{
   struct IntuiMessage *msg;

   sendtimer(microsecs);
   waittimer();

   do {
      msg=(struct IntuiMessage *)GetMsg(wd->UserPort);
   } while ((msg!=NULL) && (msg->Class!=VANILLAKEY));

   if ((msg!=NULL) && (msg->Class==VANILLAKEY)) return(msg->Code);

   return(0);
}

/* both of these are NASTY but they work */
void save_screen()
{
   memcpy(savedscreen,sc->BitMap.Planes[0],640*200>>3);
}

void restore_screen()
{
   memcpy(sc->BitMap.Planes[0],savedscreen,640*200>>3);
}

/* Screen should not get messed up */
refresh() { }
